"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var values = _ref.values,
      rules = _ref.rules,
      _ref$errors = _ref.errors,
      errors = _ref$errors === undefined ? [] : _ref$errors,
      setErrors = _ref.setErrors,
      valuesBlurred = _ref.valuesBlurred;

  var newErrors = Object.keys(rules).filter(function (rule) {
    if (errors.filter(function (error) {
      return error.name === rule;
    }).length) return true;
    if (valuesBlurred) return valuesBlurred[rule];

    return true;
  }).map(function (field) {
    return rules[field].map(function (rule) {
      var error = rule(values[field], values);

      if (!error) return false;

      return {
        name: field,
        message: error
      };
    });
  }).flatMap(function (x) {
    return x;
  }).filter(Boolean);

  setErrors(newErrors);
};